#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>

int matrixlev[8][8];
int snake_len = 4;

int x[65] = {4, 5, 6, 7};
int y[65] = {4, 4, 4, 4};

int viteza, directie = 0;

int hranax, auxx;
int hranay, auxy;

int pa_vector[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
int pc_vector[8] = {PC0, PC1, PC2, PC3, PC4, PC5, PC6, PC7};

/* matrice goala */
int matrix0[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{1, 0, 0, 1, 0, 1, 1, 1},
	{1, 0, 0, 1, 0, 0, 1, 0},
	{1, 1, 1, 1, 0, 0, 1, 0},
	{1, 0, 0, 1, 0, 0, 1, 0},
	{1, 0, 0, 1, 0, 0, 1, 0},
	{1, 0, 0, 1, 0, 1, 1, 1},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* matrice de start */
int matrix_game[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0}
};

/* litera G */
int matrixover1[8][8] =
{
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{1, 0, 0, 0, 0, 0, 0, 1},
	{1, 0, 1, 0, 0, 1, 0, 1},
	{1, 0, 0, 1, 1, 0, 0, 1},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 1, 1, 1, 1, 0, 0}
};

/* litera A */
int matrixover2[8][8] =
{
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1}
};

/* litera N */
int matrixover3[8][8] =
{
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 0, 0, 0, 1, 0},
	{0, 1, 0, 1, 0, 0, 1, 0},
	{0, 1, 0, 0, 1, 0, 1, 0},
	{0, 1, 0, 0, 0, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera E */
int matrixover4[8][8] =
{
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* SAD face */
int matrixover5[8][8] =
{
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 0, 0, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 1, 1, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* litera V */
int matrixover6[8][8] =
{
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 0, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0},
	{0, 1, 0, 1, 1, 1, 0, 1},
	{1, 0, 1, 0, 1, 0, 1, 0}
};

/* litera D */
int matrixover7[8][8] =
{
	{0, 1, 1, 1, 1, 0, 0, 0},
	{0, 1, 0, 0, 0, 1, 0, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 1, 1, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* matrice de selectie nivel 1 */
int matrixlev1[8][8] =
{
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* matrice de selectie nivel 2 */
int matrixlev2[8][8] =
{
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 0, 0, 1, 1, 0},
	{0, 1, 0, 1, 1, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* matrice de selectie nivel 3 */
int matrixlev3[8][8] =
{
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 1, 1, 1, 1, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 1, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

/* desenare matrice */
void afisaj(int matrix[8][8])
{
	int i, j;

	for (i = 0; i < 8; i++) {
		for (j = 0; j < 8; j++)
			if (matrix[j][i])
				PORTC |= (1 << pc_vector[j]);
			else
				PORTC &= ~(1 << pc_vector[j]);

		PORTA |= (1 << pa_vector[i]);
		_delay_ms(0.4);
		PORTA &= ~(1 << pa_vector[i]);
	}
}

/* functie de copiere a unei matrici pe nivel */
void copymat(int nivel)
{
	int i, j;

	/* nivel 1 */
	if (nivel == 1)
		for (i = 0; i < 8; i++)
			for (j = 0; j < 8; j++)
				matrixlev[i][j] = matrixlev1[i][j];

	/* nivel 2 */
	if (nivel == 2)
		for (i = 0; i < 8; i++)
			for (j = 0; j < 8; j++)
				matrixlev[i][j] = matrixlev2[i][j];

	/* nivel 3 */
	if (nivel == 3)
		for (i = 0; i < 8; i++)
			for (j = 0; j < 8; j++)
				matrixlev[i][j] = matrixlev3[i][j];
}

/* genereaza hrana in functie de nivel */
void eat()
{
	int a, b, i, ok;

	ok = 0;
	while (!ok) {
		ok = 1;
		/* generez doua numere random */
		a = rand() % 8;
		b = rand() % 8;

		/* verific daca punctul e deja ocupat */
		for (i = 0; i < snake_len; i++)
			if (x[i] == a && y[i] == b) {
					ok = 0;
					break;
			}

		if (ok)
			break;
	}

	hranax = a;
	hranay = b;
}

/* update matrice */
int updatare_matrice()
{
	int i, xaux, yaux;

	xaux = x[snake_len - 1];
	yaux = y[snake_len - 1];
	if (directie == 0) {
		if (!x[0]) matrix_game[7][y[0]] = 1;
		else matrix_game[x[0] - 1][y[0]] = 1;
		
		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!x[0]) x[0] = 7;
		else x[0] = x[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (directie == 1) {
		if (x[0] == 7) matrix_game[0][y[0]] = 1;
		else matrix_game[x[0] + 1][y[0]] = 1;

		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;
		
		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (x[0] == 7) x[0] = 0;
		else x[0] = x[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (directie == 2) {
		if (!y[0]) matrix_game[x[0]][7] = 1;
		else matrix_game[x[0]][y[0] - 1] = 1;

		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (!y[0]) y[0] = 7;
		else y[0] = y[0] - 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if (directie == 3) {
		if (y[0] == 7) matrix_game[x[0]][0] = 1;
		else matrix_game[x[0]][y[0]+ 1] = 1;
		
		for (i = 1; i < snake_len; i++)
			matrix_game[x[i - 1]][y[i - 1]] = matrix_game[x[i]][y[i]];

		matrix_game[x[snake_len - 1]][y[snake_len - 1]] = 0;

		for (i = snake_len - 1; i > 0; i--) {
			x[i] = x[i - 1];
			y[i] = y[i - 1];
		}

		if (y[0] == 7) y[0] = 0;
		else y[0] = y[0] + 1;

		if (x[0] == xaux && y[0] == yaux)
			return 1;
	}

	if ((x[0] == hranax) && (y[0] == hranay)) {
		x[snake_len] = auxx;
		y[snake_len] = auxy;

		matrix_game[x[snake_len]][y[snake_len]] = 1;
		snake_len++;

		eat();
		matrix_game[hranax][hranay] = 1;
	}

	/* sfarsit */
	for (i = 1; i < snake_len; i++)
		if (x[i] == x[0] && y[i] == y[0])
			return 1;

	/* retin ultima casuta */
	auxx = x[snake_len - 1];
	auxy = y[snake_len - 1];

	return 0;
	
}

int main()
{
	int i;

	for (i = 4; i < 64; i++)
		x[i] = 0, y[i] = 0;

	PORTD |= (1 << PD1); 
	PORTD |= (1 << PD0);
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	PORTD |= (1 << PD6);

	int rr = 0;
	while(1) {
		++rr;
		if (!(PIND & (1 << PD6))) break;
	}
	srand(rr);
		
	eat();
	matrix_game[hranax][hranay] = 1;
	
	DDRA = 0xFF; 
	DDRC = 0xFF; 
		
	PORTA = 0x00;
	PORTC = 0x00;

	while (1) {
	//	int x1 = 0, x2 = 0;
		i = 0;

		/* pattern matrice initiala */
		
		int patrat = 1;
//		int m = 10;
		while(patrat < 2){
			for(i = 0; i < 300; i++)
				afisaj(matrix0);
			
			for(i = 0; i < 300; i++)
				afisaj(matrixover1);
			
			for(i = 0; i < 100; i++)
				afisaj(matrixover2);
			
			for(i = 0; i < 100; i++)
				afisaj(matrixover6);
			
				for(i = 0; i < 100; i++)
				afisaj(matrixover2);
			
			for(i = 0; i < 100; i++)
				afisaj(matrixover6);
			
			patrat++;
			
		}
		
		

		int nr = 1;
		copymat(nr);

		/* comutare nivel */
		while (1) {
			while(1) {
				afisaj(matrixlev);

				if (!(PIND & (1 << PD4))) {
					nr++;
					if (nr == 4)
						nr = 1;
					copymat(nr);
					while (1) {
						afisaj(matrixlev);
						if ((PIND & (1 << PD4)))
							break;
					}
				}

				if (!(PIND & (1 << PD1))) {
					nr--;
					if (nr == 0)
						nr = 3;
					copymat(nr);
					while (1) {
						afisaj(matrixlev);
						if ((PIND & (1 << PD1)))
							break;
					}
				}

				if (!(PIND & (1 << PD6))) break;
			}

			if (!(PIND & (1 << PD6))) break;
		}

		/* viteza */ 
		if (nr == 1) viteza = 500;
		if (nr == 2) viteza = 300;
		if (nr == 3) viteza = 150;

		while(1) {
			int i = 0;
			int curr_dir = directie;

			while(i < viteza) {
				afisaj(matrix_game);
				i++;
				/* apasare buton */
				if (!(PIND & (1 << PD4)))
					if ((curr_dir == 2) || (curr_dir == 3))
						directie = 0;
				if (!(PIND & (1 << PD5)))
					if ((curr_dir == 0) || (curr_dir == 1))
						directie = 3;
				if (!(PIND & (1 << PD0)))
					if ((curr_dir == 0) || (curr_dir == 1))
						directie = 2;
				if (!(PIND & (1 << PD1)))
					if ((curr_dir == 2) || (curr_dir == 3))
						directie = 1;
			}

			int r = updatare_matrice();

			/* jocul s-a terminat */
			if (r == 1) {
				int t = 100;

				/* desenare "GAME OVER" */
				while(1) {
					for (i = 0; i < 2 * t; i++)
						afisaj(matrixover4);
					for (i = 0; i < 2 * t; i++)
						afisaj(matrixover3);
					for (i = 0; i < 2 * t; i++)
						afisaj(matrixover7);
					for (i = 0; i < 5 * t; i++)
						afisaj(matrixover5);

				}
			}
		}
	}

	return 0;
}
